Prime Path (BFS+打表)

Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179 

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

题目大意:让你将第一个数变成第二个数,每次只能改变一个位数字,改完后的数字必须是素数,找最少次数,如果不能变成另一个数输出“Impossible”,否则输出次数

思路:用BFS, 枚举每一位上的数字,如果符合要求就入列,直到变换为另一个数字,或者退出循环;

代码如下(代码很水,,,哗啦~哗啦~):

#include <iostream>
#include <cstring>
#include <cstdlib>
#include <algorithm>
#include <queue>
#include <cmath>
#include <cstdio>
#define mem(a,b)  memset(a,b,sizeof(a))

using namespace std;
typedef long long ll;
const int MAXn=10005;
//const int  mod=1000000007;
typedef struct node
{
    int n,t;
} node;
int ss[MAXn],a,b,v[MAXn];//ss用来存素数  v用来标记
void BFS(int n)
{
    int i;
    node n1;
    n1.n=n;
    n1.t=0;
    queue<node>q;
    while(!q.empty())
        q.pop();   //清空队列
    v[n]=0;
    q.push(n1);
    while(!q.empty())
    {
        node n2=q.front();
        q.pop();
        if(n2.n==b)
        {  //变换成功就输出次数(因为是用的BFS,所以次数保证最少)
            cout<<n2.t<<endl;
            return ;
        }
        for(i=1; i<=9; i++) //千位
        {
            n=n2.n%1000+i*1000;
            if(!ss[n]&&v[n]) 
            { //符合要求就存入队列并标记这个数字
                n1.n=n;
                n1.t=n2.t+1;
                v[n]=0;
                q.push(n1);
            }
        }
        for(i=0; i<=9; i++) //百位
        {
            n=n2.n/1000*1000+i*100+n2.n%100;
            if(!ss[n]&&v[n])
            {
                n1.n=n;
                n1.t=n2.t+1;
                v[n]=0;
                q.push(n1);
            }
        }
        for(i=0; i<=9; i++) //十位
        {
            n=n2.n/100*100+i*10+n2.n%10;
            if(!ss[n]&&v[n])
            {
                n1.n=n;
                n1.t=n2.t+1;
                v[n]=0;
                q.push(n1);
            }
        }
        for(i=1; i<=9; i+=2) //个位
        {
            n=n2.n/10*10+i;
            if(!ss[n]&&v[n])
            {
                n1.n=n;
                n1.t=n2.t+1;
                v[n]=0;
                q.push(n1);
            }
        }
    }
    cout<<"Impossible"<<endl;//如果找不到,输出Impossible
}
int main()
{
    mem(ss,1);
    ss[2]=ss[3]=0;
    for (int i=5; i<10000; i++) 
    {//这是一种较为快捷的素数打表方法,原理:除了2和3,其他素数不是6的倍数加一就是6的倍数减一
        if ((i+1)%6==0||(i-1)%6==0)
        {
            int j;
            for (j=2; j<(int)(sqrt(i)+1); j++)
            {
                if (i%j==0)
                    break;
            }
            if (j==(int)(sqrt(i)+1))
                ss[i]=0;
        }
    }
    int T;
    cin>>T;
    while(T--)
    {
        cin>>a>>b;
        mem(v,1);
        BFS(a);
    }
    return 0;
}

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值